function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React from 'react';
import PropTypes from 'prop-types';
import AsyncValidator from 'async-validator';
import { setDefaultProps, classNames } from '../_util/assist';
import { Consumer } from '../form/formContext';
var prefixCls = 'r-input';

var Input = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Input, _React$PureComponent);

  var _super = _createSuper(Input);

  function Input(props) {
    var _this;

    _classCallCheck(this, Input);

    _this = _super.call(this, props);

    _this.onMaskClick = function (e) {
      if (_this.props.readonly || _this.props.disabled) return;

      _this.setState({
        showInput: true
      }, function () {
        _this.inputRef.current.focus();
      });
    };

    _this.onFieldInput = function (e) {
      _this.setState({
        validateState: '',
        validateMessage: ''
      });

      var iptValue = e.target.value;
      var iptPrevValue = e.target.prevValue;
      var _this$props = _this.props,
          type = _this$props.type,
          maxlength = _this$props.maxlength,
          fixed = _this$props.fixed;

      if (type === 'number') {
        // 修复input 属性为 number，maxlength不起作用
        if (maxlength && iptValue.length > maxlength) {
          iptValue = iptValue.slice(0, maxlength);
        } // 限制小数位数


        var dotPos = iptValue.indexOf('.');
        if (fixed > 0 && dotPos > -1) iptValue = iptValue.substring(0, dotPos + fixed + 1); // 解决ios输入非数字时value清空问题

        if (e.nativeEvent && e.nativeEvent.data && e.nativeEvent.inputType) {
          var isNotNumber = !/[0-9]|\./.test(e.nativeEvent.data) && e.nativeEvent.inputType !== 'deleteContentBackward'; // 键值为非数字，并且不是后退键

          var isDoubleDot = e.nativeEvent.data === '.' && iptPrevValue.includes('.'); // 输入两个小数点

          var isIntDot = fixed <= 0 && e.nativeEvent.data === '.'; // 要求是整数但输入了小数点

          if (isNotNumber || isDoubleDot || isIntDot) iptValue = iptPrevValue;
        } // 整数时先清空，防止展示异常


        if (fixed <= 0) e.target.value = '';
      } else if (type === 'tel') {
        iptValue = telephoneClearNonNumbers(iptValue);
      } else if (type === 'IDCard') {
        iptValue = IDCardClearNonNumbers(iptValue);
      }

      if ((type === 'text' || type === 'email') && _this._state.typing) return; // 正在输入中文时不执行后面的代码

      e.target.value = iptValue;
      e.target.prevValue = iptValue;
    };

    _this.onFieldChange = function (e) {
      var iptValue = e.target.value;

      _this.setValue(iptValue, function () {
        this.props.onInput({
          event: e,
          component: this,
          value: iptValue
        });
      }, {
        event: e,
        from: 'change'
      });
    };

    _this.onFieldFocus = function (e) {
      var _this$props2 = _this.props,
          readonly = _this$props2.readonly,
          disabled = _this$props2.disabled,
          type = _this$props2.type;
      var iptValue = e.target.value;
      if (readonly || disabled) return;
      e.target.prevValue = iptValue;
      e.target.lastValue = iptValue;

      _this.setState({
        focused: true
      });

      _this.props.onFocus({
        event: e,
        component: _assertThisInitialized(_this),
        value: iptValue
      });

      type === 'email' && _this.setState({
        showEmailPan: true
      });
    };

    _this.onFieldBlur = function (e) {
      var iptValue = e.target.value;
      var onBlur = _this.props.onBlur;

      _this.setValue(iptValue, function () {
        onBlur({
          event: e,
          component: this,
          value: iptValue
        });
      }, {
        event: e,
        from: 'blur'
      });

      _this._state.blurTimer = setTimeout(function () {
        _this._state.isMounted && _this.setState({
          focused: false,
          showInput: false,
          showEmailPan: false
        });
      }, 200);
    };

    _this.onClear = function (e) {
      if (_this._state.blurTimer) clearTimeout(_this._state.blurTimer);

      _this.setValue('', function () {
        this.inputRef.current.focus();
      }, {
        event: e
      });
    };

    _this.onEmailClick = function (e) {
      var value = e.target.innerText;

      _this.setValue(value, null, {
        event: e
      });
    };

    _this.onFieldCompositionStart = function (e) {
      _this._state.typing = true; // 输入中文前
    };

    _this.onFieldCompositionEnd = function (e) {
      _this._state.typing = false; // 输入中文后
    };

    _this.state = {
      value: props.value,
      prePropsValue: props.value,
      validateState: '',
      validateMessage: '',
      focused: false,
      showEmailPan: false,
      showInput: false
    }; // 不需要驱动视图更新的数据放这里

    _this._state = {
      initialValue: '',
      validateDisabled: false,
      blurTimer: null,
      typing: false,
      // 键盘输入中文
      preValidateTime: '',
      isMounted: false
    };
    _this.inputRef = /*#__PURE__*/React.createRef();
    _this.inputWrapRef = /*#__PURE__*/React.createRef();
    return _this;
  }

  _createClass(Input, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/React.createElement(Consumer, null, function (context) {
        _this2.form = context;
        console.log('Input mounted or updated');
        var _this2$props = _this2.props,
            title = _this2$props.title,
            name = _this2$props.name,
            type = _this2$props.type,
            prepend = _this2$props.prepend,
            append = _this2$props.append,
            maxlength = _this2$props.maxlength,
            disabled = _this2$props.disabled,
            readonly = _this2$props.readonly,
            autofocus = _this2$props.autofocus;
        var _this2$state = _this2.state,
            showInput = _this2$state.showInput,
            value = _this2$state.value,
            validateMessage = _this2$state.validateMessage;
        return /*#__PURE__*/React.createElement("div", {
          className: _this2.wrapCls,
          ref: _this2.inputWrapRef
        }, /*#__PURE__*/React.createElement("div", {
          className: _this2.innerCls
        }, /*#__PURE__*/React.createElement("label", {
          className: _this2.labelCls,
          style: _this2.labelStyle
        }, title), prepend && /*#__PURE__*/React.createElement("div", {
          className: _this2.prependCls
        }, prepend), /*#__PURE__*/React.createElement("div", {
          className: _this2.contentCls
        }, !showInput && /*#__PURE__*/React.createElement("div", {
          className: _this2.inputCls,
          onClick: _this2.onMaskClick
        }, value || _this2.placeholderText), showInput && /*#__PURE__*/React.createElement("input", _extends({
          type: _this2.inputType,
          name: name,
          value: value,
          pattern: type === 'number' ? 'number' : '',
          maxLength: maxlength,
          disabled: disabled,
          readOnly: readonly,
          autoFocus: autofocus,
          placeholder: _this2.placeholderText,
          className: _this2.inputCls,
          autoComplete: "off",
          spellCheck: "false"
        }, _this2.dataset(), {
          ref: _this2.inputRef,
          onInput: _this2.onFieldInput,
          onChange: _this2.onFieldChange,
          onFocus: _this2.onFieldFocus,
          onBlur: _this2.onFieldBlur,
          onCompositionStart: _this2.onFieldCompositionStart,
          onCompositionEnd: _this2.onFieldCompositionEnd
        })), _this2.showClear && /*#__PURE__*/React.createElement("span", {
          className: _this2.clearCls,
          onClick: _this2.onClear
        }, /*#__PURE__*/React.createElement("svg", {
          width: "14px",
          height: "14px",
          style: _this2.clearStyle,
          viewBox: "0 0 14 14",
          version: "1.1",
          xmlns: "http://www.w3.org/2000/svg",
          xmlnsXlink: "http://www.w3.org/1999/xlink"
        }, /*#__PURE__*/React.createElement("g", {
          stroke: "none",
          strokeWidth: "1",
          fill: "none",
          fillRule: "evenodd"
        }, /*#__PURE__*/React.createElement("g", {
          transform: "translate(-346.000000, -238.000000)",
          fill: _this2.clearStyle.color
        }, /*#__PURE__*/React.createElement("g", {
          transform: "translate(346.000000, 238.000000)"
        }, /*#__PURE__*/React.createElement("path", {
          d: "M7,0 C3.13354657,0 0,3.13354657 0,7 C0,10.8664534 3.13354657,14 7,14 C10.8664534,14 14,10.8664534 14,7 C14,3.13354657 10.8664534,0 7,0 Z M9.97021324,4.68998284 L7.66019608,7 L9.97021324,9.31001716 C10.1500343,9.49390441 10.1472721,9.78900245 9.96331618,9.97021324 C9.78215686,10.1472721 9.49115931,10.1472721 9.31001716,9.97021324 L7,7.66019608 L4.68998284,9.97021324 C4.50609559,10.1500343 4.21099755,10.1472721 4.02978676,9.96331618 C3.85272794,9.78215686 3.85272794,9.49115931 4.02978676,9.31001716 L6.33980392,7 L4.02978676,4.68998284 C3.84996569,4.50609559 3.85272794,4.21099755 4.03668382,4.02978676 C4.21784314,3.85272794 4.50884069,3.85272794 4.68998284,4.02978676 L7,6.33980392 L9.31001716,4.02978676 C9.49390441,3.84996569 9.78900245,3.85272794 9.97021324,4.03668382 C10.1472721,4.21784314 10.1472721,4.50884069 9.97021324,4.68998284 Z",
          id: "Fill-1"
        }))))))), append && /*#__PURE__*/React.createElement("div", {
          className: _this2.appendCls
        }, append), _this2.showErrorMsg && /*#__PURE__*/React.createElement("div", {
          className: _this2.errorCls
        }, validateMessage)), _this2.showEmailPanel && /*#__PURE__*/React.createElement("div", {
          className: _this2.emailPanel
        }, _this2.filteredEmailList.map(function (emailSuffix, idx) {
          return /*#__PURE__*/React.createElement("div", {
            className: _this2.emailPanelItem,
            key: idx,
            onClick: _this2.onEmailClick,
            dangerouslySetInnerHTML: {
              __html: (_this2.state.value.split('@')[0] + '@' + emailSuffix).replace(_this2.state.value, function (text) {
                return "<font>".concat(text, "</font>");
              })
            }
          });
        })));
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.form && this.form._state.fields.push(this);
      this._state.initialValue = this._state.prevValue = this.state.value;
      this._state.isMounted = true;
      this.$el = this.inputWrapRef.current;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.form && this.form._state.fields.splice(this.form._state.fields.indexOf(this), 1);
      this._state.isMounted = false;
    }
  }, {
    key: "wrapCls",
    get: function get() {
      var _ref;

      var _this$state = this.state,
          focused = _this$state.focused,
          value = _this$state.value;
      var _this$props3 = this.props,
          type = _this$props3.type,
          labelPosition = _this$props3.labelPosition,
          textPosition = _this$props3.textPosition,
          mode = _this$props3.mode,
          className = _this$props3.className,
          readonly = _this$props3.readonly;

      var _labelPosition = labelPosition || this.form && this.form.props.labelPosition || 'left';

      var _textPosition = textPosition || this.form && this.form.props.textPosition || 'left';

      var _mode = mode || this.form && this.form.props.mode || 'default';

      return classNames([this.form && 'form-item', prefixCls, "".concat(prefixCls, "-label-").concat(_labelPosition), "".concat(prefixCls, "-text-").concat(_textPosition), "".concat(prefixCls, "-mode-").concat(_mode), className, (_ref = {}, _defineProperty(_ref, "".concat(prefixCls, "-focused"), focused), _defineProperty(_ref, "".concat(prefixCls, "-empty"), value === ''), _defineProperty(_ref, "".concat(prefixCls, "-error"), this.showErrorMsg), _defineProperty(_ref, "".concat(prefixCls, "-show-clear"), this.showClear), _defineProperty(_ref, "".concat(prefixCls, "-hidden"), type === 'hidden'), _defineProperty(_ref, "".concat(prefixCls, "-email"), type === 'email'), _defineProperty(_ref, "".concat(prefixCls, "-required"), this.isRequired), _defineProperty(_ref, "".concat(prefixCls, "-readonly"), !!readonly), _defineProperty(_ref, "".concat(prefixCls, "-placeholder"), value === ''), _ref)]);
    }
  }, {
    key: "innerCls",
    get: function get() {
      return "".concat(prefixCls, "-inner");
    }
  }, {
    key: "labelCls",
    get: function get() {
      return "".concat(prefixCls, "-label");
    }
  }, {
    key: "labelStyle",
    get: function get() {
      var style = {};

      if (this.labelWidth || this.labelWidth === 0) {
        style.width = this.labelWidth;
      } else if (this.form && (this.form.props.labelWidth || this.form.props.labelWidth === 0)) {
        style.width = this.form.props.labelWidth;
      }

      return style;
    }
  }, {
    key: "prependCls",
    get: function get() {
      return "".concat(prefixCls, "-prepend");
    }
  }, {
    key: "appendCls",
    get: function get() {
      return "".concat(prefixCls, "-append");
    }
  }, {
    key: "placeholderText",
    get: function get() {
      return this.props.placeholder || this.form && this.form.props.placeholder || '';
    }
  }, {
    key: "clearStyle",
    get: function get() {
      var style = {
        color: '#C8C7CC'
      };
      return this.props.inputClearStyle || this.form && this.form.props.inputClearStyle || style;
    }
  }, {
    key: "contentCls",
    get: function get() {
      return "".concat(prefixCls, "-content");
    }
  }, {
    key: "inputCls",
    get: function get() {
      return "".concat(prefixCls, "-input");
    }
  }, {
    key: "clearCls",
    get: function get() {
      return "".concat(prefixCls, "-clear");
    }
  }, {
    key: "unitCls",
    get: function get() {
      return "".concat(prefixCls, "-unit");
    }
  }, {
    key: "showClear",
    get: function get() {
      return this.state.focused && String(this.state.value).length > 0;
    }
  }, {
    key: "errorCls",
    get: function get() {
      return "".concat(prefixCls, "-error-tip");
    }
  }, {
    key: "inputType",
    get: function get() {
      var type = this.props.type; // 'tel', 'number', 'text', 'IDCard'

      return type === 'IDCard' ? 'text' : type;
    }
  }, {
    key: "fieldRules",
    get: function get() {
      var _this$props4 = this.props,
          title = _this$props4.title,
          type = _this$props4.type,
          rules = _this$props4.rules;
      var defaultRules = [{
        required: true,
        message: "".concat(title, "\u4E0D\u80FD\u4E3A\u7A7A")
      }];

      if (type === 'IDCard') {
        defaultRules.push({
          validator: function validator(rule, value, callback) {
            if (!IDCardVerify(value)) {
              return new Error('身份证格式不正确');
            }

            callback();
          },
          trigger: 'blur'
        });
      } else if (type === 'email') {
        defaultRules.push({
          type: "email",
          message: "邮箱格式不正确",
          trigger: "blur"
        });
      }

      return [].concat(rules ? rules : defaultRules);
    }
  }, {
    key: "isRequired",
    get: function get() {
      if (this.props.required === false) {
        return false;
      }

      return this.fieldRules.some(function (item) {
        return item.required === true;
      });
    }
  }, {
    key: "showErrorMsg",
    get: function get() {
      return this.state.validateState === 'error' && (this.form ? this.form.props.showMessage && this.props.showMessage : this.props.showMessage);
    }
  }, {
    key: "emailPanel",
    get: function get() {
      return "".concat(prefixCls, "-email-panel");
    }
  }, {
    key: "emailPanelItem",
    get: function get() {
      return "".concat(prefixCls, "-email-panel--item");
    }
  }, {
    key: "filteredEmailList",
    get: function get() {
      var emailList = this.props.emailList;
      var value = this.state.value;
      var emailSuffix = value.split('@')[1];
      var arr = [];

      if (!emailSuffix && value.length) {
        return emailList;
      }

      for (var i = 0; i < emailList.length; i++) {
        var email = emailList[i].replace('@', '');

        if (email.indexOf(emailSuffix) > -1) {
          arr.push(email);
        }
      }

      return arr;
    }
  }, {
    key: "showEmailPanel",
    get: function get() {
      var _this$state2 = this.state,
          value = _this$state2.value,
          showEmailPan = _this$state2.showEmailPan;
      var currEmailSuffix = String(value).split("@")[1];
      return this.props.type === 'email' && showEmailPan && (this.filteredEmailList.length > 1 || this.filteredEmailList.length === 1 && this.filteredEmailList[0] !== currEmailSuffix);
    } // input添加dataset数据，外部可以通过e.target.dataset获取

  }, {
    key: "dataset",
    value: function dataset() {
      var obj = {};

      for (var key in this.props) {
        if (key.startsWith('data-')) obj[key] = this.props[key];
      }

      return obj;
    }
  }, {
    key: "getFilterRules",
    value: function getFilterRules(trigger) {
      return this.fieldRules.filter(function (rule) {
        return !rule.trigger || rule.trigger.indexOf(trigger) !== -1;
      });
    }
  }, {
    key: "validate",
    value: function validate(trigger) {
      var _this3 = this;

      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
      // 防止blur后直接点击btn重复调用validate方法
      var timeNow = new Date().getTime();
      if (this._state.preValidateTime && timeNow - this._state.preValidateTime < 50) return;
      this._state.preValidateTime = timeNow;
      var value = this.state.value;
      var initialValue = this._state.initialValue;
      var _this$props5 = this.props,
          name = _this$props5.name,
          title = _this$props5.title;
      var isMaskCode = initialValue.indexOf('*') > -1 && initialValue === value; // 掩码

      var rules = this.getFilterRules(trigger);

      if (!this.isRequired || isMaskCode) {
        callback();
        return true;
      }

      this._state.validateDisabled = false;
      var prop = name || title || 'prop';
      var descriptor = {};
      descriptor[prop] = rules;
      var validator = new AsyncValidator(descriptor);
      var model = {};
      model[prop] = value;
      validator.validate(model, {
        first: true,
        suppressWarning: true,
        component: this
      }).then(function () {
        _this3.setState({
          validateState: 'success',
          validateMessage: ''
        });

        callback('');
      }).catch(function (_ref2) {
        var errors = _ref2.errors,
            fields = _ref2.fields;
        var errMsg = errors[0].message || '';

        _this3.setState({
          validateState: 'error',
          validateMessage: errMsg
        });

        callback(errMsg);
      });
    }
  }, {
    key: "resetField",
    value: function resetField() {
      this._state.validateDisabled = true;
      this.setState({
        validateState: '',
        validateMessage: ''
      });
      this.setValue(this._state.initialValue, null, {
        from: 'reset'
      });
    }
    /* 获取表单数据 */

  }, {
    key: "getValue",
    value: function getValue() {
      return {
        name: this.props.name,
        value: this.state.value
      };
    }
  }, {
    key: "setValue",
    value: function setValue(value, callback) {
      var _this4 = this;

      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var opts = Object.assign({
        event: null,
        component: this,
        value: value
      }, options);
      var from = options.from;
      this._state.isMounted && this.setState({
        value: value
      }, function () {
        _this4.props.onChange(opts);

        _this4.form && _this4.form.onChange(opts);
        callback && callback.call(_this4);

        if (from === 'blur' || from === 'reset') {
          if (_this4._state.validateDisabled) {
            _this4._state.validateDisabled = false;
          } else {
            _this4.validate('blur');
          }
        }
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.value !== prevState.prePropsValue) {
        return {
          value: nextProps.value,
          prePropsValue: nextProps.value
        };
      }

      return null;
    }
  }]);

  return Input;
}(React.PureComponent);

setDefaultProps(Input, {
  type: {
    type: PropTypes.string,
    default: 'text'
  },
  title: {
    type: PropTypes.string
  },
  value: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    default: ''
  },
  placeholder: {
    type: PropTypes.string
  },
  maxlength: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
  },
  fixed: {
    type: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
  },
  disabled: {
    type: PropTypes.oneOf(['disabled', 1, 0, true, false])
  },
  readonly: {
    type: PropTypes.oneOf(['readonly', 1, 0, true, false])
  },
  autofocus: {
    type: PropTypes.oneOf(['autofocus', 1, 0, true, false])
  },
  emailList: {
    type: PropTypes.array,
    default: []
  },
  labelPosition: {
    type: PropTypes.oneOf(['left', 'right', 'top'])
  },
  labelWidth: {
    type: PropTypes.string
  },
  textPosition: {
    type: PropTypes.oneOf(['left', 'center', 'right'])
  },
  inputClearStyle: {
    type: PropTypes.object
  },
  // 是否显示校验错误信息
  showMessage: {
    type: PropTypes.bool,
    default: true
  },
  // 校验规则
  rules: {
    type: PropTypes.array
  },
  required: {
    type: PropTypes.bool
  },
  onChange: {
    type: PropTypes.func,
    default: function _default() {}
  },
  onInput: {
    type: PropTypes.func,
    default: function _default() {}
  },
  onFocus: {
    type: PropTypes.func,
    default: function _default() {}
  },
  onBlur: {
    type: PropTypes.func,
    default: function _default() {}
  },
  mode: {
    type: PropTypes.string
  }
});

function telephoneClearNonNumbers(str) {
  // 先把非数字的都替换掉，除了数字和.
  str = str.replace(/[^\d]/g, "");
  return str;
}

function IDCardClearNonNumbers(str) {
  // 身份证不超过15或18位数字，最后一位是X或者x，超过18截掉
  if (str.length > 18) {
    str = str.substr(0, 18);
  }

  if (str.length < 15 || str.length > 15 && str.length < 18) {
    str = str.replace(/[^\d]/g, "");
  }

  if (str.length == 15 || str.length == 18) {
    var str1 = str.substr(0, str.length - 1);
    var str2 = str.substr(str.length - 1, 1);
    str1 = str1.replace(/[^\d]/g, "");
    str2 = str2.replace(/[^\dXx]/g, "");
    str = str1 + str2;
  }

  return str;
}

function IDCardVerify(idcard) {
  var pass = false;
  var area = {
    11: "北京",
    12: "天津",
    13: "河北",
    14: "山西",
    15: "内蒙古",
    21: "辽宁",
    22: "吉林",
    23: "黑龙江",
    31: "上海",
    32: "江苏",
    33: "浙江",
    34: "安徽",
    35: "福建",
    36: "江西",
    37: "山东",
    41: "河南",
    42: "湖北",
    43: "湖南",
    44: "广东",
    45: "广西",
    46: "海南",
    50: "重庆",
    51: "四川",
    52: "贵州",
    53: "云南",
    54: "西藏",
    61: "陕西",
    62: "甘肃",
    63: "青海",
    64: "宁夏",
    65: "新疆",
    71: "台湾",
    81: "香港",
    82: "澳门",
    91: "国外"
  };
  var Y, JYM, ereg;
  var S, M;
  var idcardArray = [];
  idcardArray = idcard.split("");

  if (area[parseInt(idcard.substr(0, 2))] == null) {
    return false;
  }

  switch (idcard.length) {
    case 15:
      pass = false;
      break;

    case 18:
      if (parseInt(idcard.substr(6, 4)) % 4 == 0 || parseInt(idcard.substr(6, 4)) % 100 == 0 && parseInt(idcard.substr(6, 4)) % 4 == 0) {
        ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}[0-9Xx]$/; // 闰年出生日期的合法性正则表达式
      } else {
        ereg = /^[1-9][0-9]{5}(19|20)[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}[0-9Xx]$/; // 平年出生日期的合法性正则表达式
      }

      if (ereg.test(idcard)) {
        S = (parseInt(idcardArray[0]) + parseInt(idcardArray[10])) * 7 + (parseInt(idcardArray[1]) + parseInt(idcardArray[11])) * 9 + (parseInt(idcardArray[2]) + parseInt(idcardArray[12])) * 10 + (parseInt(idcardArray[3]) + parseInt(idcardArray[13])) * 5 + (parseInt(idcardArray[4]) + parseInt(idcardArray[14])) * 8 + (parseInt(idcardArray[5]) + parseInt(idcardArray[15])) * 4 + (parseInt(idcardArray[6]) + parseInt(idcardArray[16])) * 2 + parseInt(idcardArray[7]) * 1 + parseInt(idcardArray[8]) * 6 + parseInt(idcardArray[9]) * 3;
        Y = S % 11;
        M = "F";
        JYM = "10X98765432";
        M = JYM.substr(Y, 1);

        if (M.toLowerCase() == idcardArray[17].toLowerCase()) {
          pass = true;
        } else {
          pass = false;
        }
      } else {
        pass = false;
      }

      break;

    default:
      pass = false;
      break;
  }

  ;
  return pass;
}

export default Input;